using System.Runtime.Serialization;

namespace CoreLibrary.Exceptions
{
    /// <summary>
    /// Exception levée lorsqu'une taille de code invalide est spécifiée.
    /// </summary>
    [Serializable]
    public class TailleCodeException : Exception
    {
        /// <summary>
        /// Initialise une nouvelle instance de la classe <see cref="TailleCodeException"/>.
        /// </summary>
        /// <param name="taille">La taille du code spécifiée.</param>
        private const string messageDefaut = "Un code doit avoir une taille positive non nulle.";

        public TailleCodeException() : base(messageDefaut)
        { }

        public TailleCodeException(int taille) :
            base($"Un code doit avoir une taille positive non nulle, or il a reçu {taille}.")
        { }

        public TailleCodeException(string message) : base(message)
        { }

        public TailleCodeException(string message, Exception exception) : base(message, exception)
        { }

        [Obsolete("This method is obsolete. Use alternative methods for data retrieval.", DiagnosticId = "SYSLIB0051")]
        protected TailleCodeException(SerializationInfo info, StreamingContext contexte) : base(info, contexte) { }

        [Obsolete("This method is obsolete. Use alternative methods for data retrieval.", DiagnosticId = "SYSLIB0051")]
        public override void GetObjectData(SerializationInfo info, StreamingContext context)
        {
            base.GetObjectData(info, context);
        }
    }
}
